# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Defined types**

* [`chown_r`](#chown_r): recursive chown

## Defined types

### chown_r

Defined Resource Type to carry out chown -R when required.  This avoids
having to use recursive `file` resources with large directories as this
can bring about poor performance in the Puppet Master as well as placing
high demand on storage requirements

#### Parameters

The following parameters are available in the `chown_r` defined type.

##### `dir`

Data type: `String`

The directory to check and chown.  Defaults to $name

Default value: $name

##### `want_user`

Data type: `Optional[String]`

The user ID to chown to and check for

Default value: `undef`

##### `want_group`

Data type: `Optional[String]`

The group ID to chown to and check for

Default value: `undef`

##### `watch`

Data type: `Optional[Variant[Type[Resource], Array[Type[Resource]]]]`

Resource reference to watch (eg Package['foo']), if set, we will only
run the chown if this resource sends a refresh event AND we identify
files with incorrect ownership.  Note that if this parameter is not set,
the chown command will run every time find tells us we need to (eg
up to every puppet run)

Default value: `undef`

##### `skip`

Data type: `Optional[String]`

Do not include this directory when running chmod

Default value: `undef`

##### `options`

Data type: `Optional[String]`

Additional options to pass to the `chown` or `chgrp` command

Default value: "-h"

